<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.11 $
 * $Author: tora60 $
 * $Date: 2014-03-19 14:55:57 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(__DIR__));

unset($sqlqry);

if (!isset($tables["${prefix}_reviews"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_reviews` (
  `id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `title` varchar(80) NOT NULL default '',
  `text` text NULL,
  `reviewer` varchar(25) NOT NULL default '',
  `score` tinyint(2) NOT NULL default '0',
  `cover` text,
  `url` varchar(255) default NULL,
  `url_title` varchar(80) default NULL,
  `hits` int(7) NOT NULL default '0',
  `rlanguage` varchar(40) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;
";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_reviews"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_reviews");
    switch (true) {
        case $tf['date']['Type'] != 'int(11)':
            $result = sql_query("SELECT `id` FROM `{$prefix}_reviews` WHERE `date` LIKE '%-%-%' LIMIT 1");
            if (sql_num_rows($result)) {
                // versuchen anständig umzuwandeln, YYYY-MM-DD zu Unixtimestamp
                $sqlqry[] = "UPDATE `{$prefix}_reviews` SET `date` = UNIX_TIMESTAMP(`date`) WHERE `date` LIKE '%-%-%'";
            }
            // dann auf jeden Fall noch nach Integer konvertieren
            $sqlqry[] = "UPDATE `{$prefix}_reviews` SET `date` = CAST(`date` AS UNSIGNED)";
            // kein Break !!
        case $tf['title']['Default'] === null:
        case $tf['title']['Type'] != 'varchar(80)':
        case $tf['text']['Default'] !== null:
        case $tf['reviewer']['Default'] === null:
        case $tf['reviewer']['Type'] != 'varchar(25)':
        case $tf['rlanguage']['Default'] === null:
        case $tf['rlanguage']['Type'] != 'varchar(40)':
        case $tf['id']['Type'] != 'int(11)':
        case $tf['score']['Type'] != 'tinyint(2)':
        case $tf['cover']['Type'] != 'text':
        case $tf['url']['Type'] != 'varchar(255)':
        case $tf['url_title']['Type'] != 'varchar(80)':
        case $tf['hits']['Type'] != 'int(7)':
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews`
                CHANGE `title` `title` varchar(80) NOT NULL default '',
                CHANGE `text` `text` text NULL,
                CHANGE `reviewer` `reviewer` varchar(25) NOT NULL default '',
                CHANGE `rlanguage` `rlanguage` varchar(40) NOT NULL default '',
                CHANGE `id` `id` INT(11) NOT NULL auto_increment,
                CHANGE `date` `date` INT(11) NOT NULL default '0',
                CHANGE `score` `score` tinyint(2) NOT NULL default '0',
                CHANGE `cover` `cover` text,
                CHANGE `url` `url` varchar(255),
                CHANGE `url_title` `url_title` varchar(80),
                CHANGE `hits` `hits` INT(7) NOT NULL default '0'
                ";
    }
    // Felder anfügen / löschen
    if (isset($tf['email'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews` DROP `email`;";
    // wenn das neue Feld active noch nicht vorhanden war, alle Testberichte aktivieren
    if (!isset($tf['active'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_reviews` ADD `active` tinyint(1) NOT NULL default '0' AFTER `rlanguage`;";
        $sqlqry[] = "UPDATE `${prefix}_reviews` SET `active` = 1 WHERE `active` = 0;";
    }
}
// Kommentare
if (!isset($tables["${prefix}_reviews_comments"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_reviews_comments` (
  `cid` int(11) NOT NULL auto_increment,
  `rid` int(11) NOT NULL default '0',
  `username` varchar(25) NOT NULL default '',
  `date` INT(11) NOT NULL default '0',
  `comments` text NULL,
  `score` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `username` (`username`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}
// // unnötige Tabellen umbenennen
if (isset($tables["${prefix}_reviews_add"])) $sqlqry[] = "RENAME TABLE `${prefix}_reviews_add` TO `" . RENAME_PREFIX . "${prefix}_reviews_add`;";
if (isset($tables["${prefix}_reviews_main"])) $sqlqry[] = "RENAME TABLE `${prefix}_reviews_main` TO `" . RENAME_PREFIX . "${prefix}_reviews_main`;";

if (isset($tables["${prefix}_reviews_comments"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_reviews_comments");
    if (isset($tf['userid'])) {
        if (isset($tf['username'])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP `userid` ;";
        } else {
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `userid` `username` VARCHAR( 25 ) NOT NULL default '';";
        }
        if (isset($sqlqry)) {
            setupDoAllQueries($sqlqry);
            unset($sqlqry);
        }
        // Felder neu einlesen
        $tf = setupGetTableFields("${prefix}_reviews_comments");
    }

    switch (true) {
        case $tf['date']['Type'] != 'int(11)':
            $qry = "SELECT `cid` FROM `{$prefix}_reviews_comments` WHERE `date` LIKE '%-%-%' LIMIT 1";
            $result = sql_query($qry);
            if (sql_num_rows($result)) {
                // versuchen anständig umzuwandeln, YYYY-MM-DD zu Unixtimestamp
                $sqlqry[] = "UPDATE `{$prefix}_reviews_comments` SET `date` = UNIX_TIMESTAMP(`date`) WHERE `date` LIKE '%-%-%'";
            }
            // dann auf jeden Fall noch nach Integer konvertieren
            $sqlqry[] = "UPDATE `{$prefix}_reviews_comments` SET `date` = CAST(`date` AS UNSIGNED)";
            // kein Break !!
        case $tf['username']['Default'] === null:
        case $tf['username']['Type'] != 'varchar(25)':
        case $tf['comments']['Default'] !== null:
        case $tf['comments']['Type'] != 'text':
        case $tf['cid']['Type'] != 'int(11)':
        case $tf['rid']['Type'] != 'int(11)':
        case $tf['score']['Type'] != 'tinyint(2)':
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments`
                CHANGE `username` `username` varchar(25) NOT NULL default '',
                CHANGE `comments` `comments` text NULL,
                CHANGE `cid` `cid` INT(11) NOT NULL AUTO_INCREMENT,
                CHANGE `rid` `rid` int(11) NOT NULL default '0',
                CHANGE `date` `date` INT(11) NOT NULL default '0',
                CHANGE `score` `score` tinyint(2) NOT NULL default '0'
                ";
    }
    // Indexe aktualisieren
    $indexes = setupGetTableIndexes("${prefix}_reviews_comments");
    if (isset($tf['userid'])) {
        if (isset($indexes['userid'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP INDEX `userid` ";
        if (isset($indexes['username'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP INDEX `username` ;";
    }
    if (!isset($indexes['username'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` ADD INDEX username( `username` ) ;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_reviews"])) {
    // Pagebreaks konvertieren
    $sqlqry = setup_convert_pagebreak("${prefix}_reviews", 'text', 'id');
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>